static int camacCinitialize (unsigned int crate) 
{
  if (crate>3) return -1;
  outl(((unsigned long)crate)<<16,BASE_ADDRESS+4);
  outl(0x02,BASE_ADDRESS); /* LAM enable + Initialize*/
  cycle_wait(255);
  if(inl(BASE_ADDRESS)&0x20!=0)return 0;
  return -1;
}

static int camacCz () 
{
  outl((inl(BASE_ADDRESS)&0x8c)|0x02,BASE_ADDRESS);
  return cycle_wait(255);
}

static int camacCc () {
  outl((inl(BASE_ADDRESS)&0x8c)|0x01,BASE_ADDRESS);
  return cycle_wait(255);
}

static int camacCi (int onoff ) {
  if (onoff!=0) outl((inl(BASE_ADDRESS)&0x88)|0x04,BASE_ADDRESS);
  else          outl((inl(BASE_ADDRESS)&0x88)|0x00,BASE_ADDRESS);
  return 0;
}

static long camacClamp (){
  long lampat;
  return inl(BASE_ADDRESS+4);
}

static int camacClam (){
  int i, lampat;
  lampat=inl(BASE_ADDRESS+4);
  for(i=0;i<24;i++) if((lampat>>i)%2) goto lamhit;
 lamhit: 
  if(i<24) return(i+1);
  return(0);
}

static int camacCNAF(int C, int N, int A, int F, long *data, int *stat) 
{
/* long word data NAF operation */
  register int i; short status;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|
       (((unsigned long)C&0x7)<<16),BASE_ADDRESS+4);
  if((F&0x18)==0x10) /* write operation */
    outl(((*data)&0x00ffffff),BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<256;i++) {
    if(((*stat=inl(BASE_ADDRESS))&0x10)!=0) {
      *stat=(~(*stat))&0x03;
      if((F&0x18)==0x00)  /* read operation */
	*data=inl(BASE_ADDRESS+8);
      return 0;
    }
  }
  return -1;
}

static int camacNAF(int N, int A, int F, long *data, int *stat) {
/* long word data NAF operation */
  register int i; short status;
  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9),BASE_ADDRESS+4);
  if((F&0x18)==0x10) /* write operation */
    outl(((*data)&0x00ffffff),BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<256;i++) {
    if(((*stat=inl(BASE_ADDRESS))&0x10)!=0) {
      *stat=(~(*stat))&0x03;
      if((F&0x18)==0x00)  /* read operation */
	*data=inl(BASE_ADDRESS+8);
      return 0;
    }
  }
  return -1;
}

static int camacCNAF2(int C, int N, int A, int F, short *data, int *stat) 
{
/* long word data NAF operation */
  register int i; short status;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|
       (((unsigned long)C&0x7)<<16),BASE_ADDRESS+4);
  if((F&0x18)==0x10) /* write operation */
    outl(((*data)&0x00ffffff),BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<256;i++) {
    if((*stat=inl(BASE_ADDRESS)&0x10)!=0) {
      *stat=(~(*stat))&0x03;
      if((F&0x18)==0x00)  /* read operation */
	*data=inl(BASE_ADDRESS+8)&0xffff;
      return 0;
    }
  }
  return -1;
}

static int camacNAF2(int N, int A, int F, short *data, int *stat) {
/* long word data NAF operation */
  register int i; short status;
  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9),BASE_ADDRESS+4);
  if((F&0x18)==0x10) /* write operation */
    outl(((*data)&0x00ffffff),BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<256;i++) {
    if((*stat=inl(BASE_ADDRESS)&0x10)!=0) {
      *stat=(~(*stat))&0x03;
      if((F&0x18)==0x00)  /* read operation */
	*data=inl(BASE_ADDRESS+8)&0xffff;
      return 0;
    }
  }
  return -1;
}

int inline camac_NAF(int N, int A, int F) 
{
  register long i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9),BASE_ADDRESS+4);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0) return (j&3);
  }
  return -1;
}

void inline camac_write16(unsigned short data)
{
  outl((data&0x00ffffff),BASE_ADDRESS+8);
}
void inline camac_write24(long data)
{
  outl(data,BASE_ADDRESS+8);
}
unsigned short inline camac_read16()
{
  return ((unsigned short )inl(BASE_ADDRESS+8)&0xffff);
}
long inline camac_read24()
{
  return (inl(BASE_ADDRESS+8));
}


int inline camac_CNAF(int C,int N, int A, int F) 
{
  register int i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|(((unsigned long)C&0x7)<<16),
       BASE_ADDRESS+4);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0) return (j&3);
  }
  return -1;
}
int inline camac_CNAFW16(int C,int N, int A, int F, unsigned short data)
{
  register int i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|(((unsigned long)C&0x7)<<16),
       BASE_ADDRESS+4);
  outl((data&0x00ffffff),BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0) return (j&3);
  }
  return -1;
}
int inline camac_CNAFW24(int C,int N, int A, int F, long data)
{
  register int i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|(((unsigned long)C&0x7)<<16),
       BASE_ADDRESS+4);
  outl(data,BASE_ADDRESS+8);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0) return (j&3);
  }
  return -1;
}
unsigned short inline camac_CNAFR16(int C,int N, int A, int F)
{
  register int i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|(((unsigned long)C&0x7)<<16),
       BASE_ADDRESS+4);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0)   return ((unsigned short )inl(BASE_ADDRESS+8)&0xffff);
  }
  return -1;
}
long inline camac_CNAFR24(int C,int N, int A, int F)
{
  register int i,j;

  outl((F&0x1f)|((A&0x0f)<<5)|(((N-1)&0x1f)<<9)|(((unsigned long)C&0x7)<<16),
       BASE_ADDRESS+4);
  outl(0,BASE_ADDRESS+12);
  for(i=0;i<512;i++){
    j=inl(BASE_ADDRESS);
    if((j&0x10)!=0)   return ((long)inl(BASE_ADDRESS+8));
  }
  return -1;
}




